var Binary = require('../lib/binary').Binary;

var ByteArray = exports.ByteArray = function() {
	if(!(this instanceof ByteArray)) {
		if(arguments.length == 0)
			return new ByteArray();
		if(arguments.length == 1)
			return new ByteArray(arguments[0]);
		if(arguments.length == 2)
			return new ByteArray(arguments[0], arguments[1]);
	}

	// ByteArray() - construct an empty byte string
	if(arguments.length === 0) {
		this.buffer = new Buffer(0);
	}
	// ByteArray(length) - create ByteArray of specified size
	else if(arguments.length === 1 && typeof arguments[0] === "number") {
		this.buffer = new Buffer(arguments[0]);
		this.buffer.fill(0);
	}
	// ByteArray(length) - create ByteArray of specified size, but don't clear
	else if(arguments.length === 2 && typeof arguments[0] === "number"
			&& typeof arguments[1] === "boolean") {
		this.buffer = new Buffer(arguments[0]);
		if(arguments[1] === true) {
			this.buffer.fill(0);
		}
	}
	// ByteArray(byteString or byteArray) - use the contents of byteString or
	// byteArray
	else if(arguments.length === 1
			&& (arguments[0] instanceof ByteString || arguments[0] instanceof ByteArray)) {
		var source = arguments[0];
		this.buffer = new Buffer(source.length);
		source.buffer.copy(this.buffer);
	}
	// ByteArray(arrayOfNumbers) - use the numbers in arrayOfNumbers as the bytes
	else if(arguments.length === 1 && Array.isArray(arguments[0])) {
		this.buffer = new Buffer(arguments[0]);
	}
	// ByteArray(buffer) - use contents of buffer
	else if(arguments.length === 1 && arguments[0] instanceof Buffer) {
		var buffer = arguments[0];
		this.buffer = new Buffer(buffer.length);
		buffer.copy(this.buffer);
	}
	// ByteArray(string, charset) - convert a string - the ByteArray will contain
	// string encoded with charset
	else if((arguments.length === 1 || (arguments.length === 2 && arguments[1] === undefined))
			&& typeof arguments[0] === "string") {
		this.buffer = new Buffer(arguments[0]);
	} else if(arguments.length === 2 && typeof arguments[0] === "string"
			&& typeof arguments[1] === "string") {
		this.buffer = new Buffer(arguments[0], encodings[arguments[1]]);
	} else {
		throw new Error("Illegal arguments to ByteArray constructor");
	}

	return this;
};


Object.defineProperty(ByteArray.prototype, 'length', {
	get: function() {
		return this.buffer.length;
	},
	set: function(length) {
		var buffer = new Buffer(length);
		length = Math.min(this.buffer.length, length);
		this.buffer.copy(buffer, 0, 0, length);
		buffer.fill(0, length);
		this.buffer = buffer;
	}
});


var start = new Date().getTime();
for(var i = 0; i < 100000; i ++) {
	b = new ByteArray(1024);
	//b = new Buffer(1024);
}
console.log(new Date().getTime() - start);

